Index: fedkit/splitter.pl
===================================================================
--- fedkit/splitter.pl	(revision ccfc03d5d63de7063127dd4d609f7fe82e65f610)
+++ fedkit/splitter.pl	(revision 1a8a08a09737337f998508eac6c2a6b29020f0f7)
@@ -802,17 +177,13 @@
 
 	# If we know the testbed, start collecting its sub experiment tcl
-	# description.  If not, warn the user.
-	if ($tbparams->{$ctb}->{'access'}) {
+	# description.  If not, warn the caller and ignore the configuration of
+	# this testbed.
+	if ($host{$ctb}) {
 	    $allocated{$ctb}++;	# Keep track of the testbeds allocated
-
-	    unless (-d "$tmpdir/$ctb") {
-		mkdir("$tmpdir/$ctb") || die "Can't create $tmpdir/$ctb: $!";
-	    }
-	    $destfile = "$tmpdir/$ctb/$eid.$ctb.tcl";
-
-	    $desthandle = new IO::File(">$destfile") || 
-		die "Cannot open $destfile:$!\n";
+	    $destfile = "./$eid.$ctb.tcl";
+
+	    open(FILE, ">$destfile") || die "Cannot open $destfile:$!\n";
 	}
-	else{
+	else { 
 	    warn "No such testbed $ctb\n";
 	    $destfile = "";
@@ -820,53 +191,10 @@
 	next;
     };
-
     # End of that experiment
     /^#\s+End\s+Testbed\s+\((\w+)\)/ && do {
 	# Simple syntax check and close out this experiment's tcl description
 	die "Mismatched testbed markers ($1, $ctb)\n" unless ($1 eq $ctb);
-	$desthandle->close() if $desthandle;
+	close(FILE);
 	$destfile = $ctb = "";
-	next;
-    };
-
-    # Beginning of a gateway set
-    /^#\s+Begin\s+gateways\s+\((\w+)\)/ && do {
-	$gateways = $1;
-	# If we've heard of this tb, create the config lines for it one at a
-	# time.
-	if ($allocated{$gateways}) {
-	    # Just in case.  This directory should already have been created
-	    # above.
-	    unless (-d "$tmpdir/$gateways") {
-		mkdir("$tmpdir/$gateways") || 
-		    die "Can't create $tmpdir/$gateways: $!";
-	    }
-	}
-	else {
-	    warn "Gateways given (and ignored) for testbed not in use: " .
-		"$gateways\n";
-	    $gateways = 0;
-	}
-	next;
-    };
-    # End of the gateways section.  Output the client config for this testbed
-    /^#\s+End\s+gateways\s+\((\w+)\)/ && do {
-	die "Mismatched gateway markers ($1, $gateways)\n" 
-	    unless !$gateways || $gateways == $1;
-
-	if ($control_gateway ) {
-	    # Client config
-	    my $cc = new IO::File(">$tmpdir/$gateways/client.conf");
-	    my $master_project = $tbparams->{$master}->{'project'};
-	    die "Can't open $tmpdir/$gateways/client.conf: $!\n" unless $cc;
-	    print $cc "ControlGateway: $control_gateway\n";
-	    print $cc "SMBShare: $smb_share\n";
-	    print $cc "ProjectUser: $project_user\n";
-	    print $cc "ProjectName: $master_project\n";
-	    $cc->close();
-	}
-	else { warn "No control gateway for $gateways?\n"; }
-	    
-	$gateways = 0;
 	next;
     };
@@ -874,259 +202,56 @@
     # file.
     /^#\s+Begin\s+hostnames/ && do {
-	$destfile = "$tmpdir/hostnames";
-	$desthandle = new IO::File(">$destfile") || 
-	    die "Can't open $destfile:$!\n";
+	$destfile = "./hostnames";
+	open(FILE, ">$destfile") || die "Can't open $destfile:$!\n";
 	next;
     };
     # end of the hostnames list.
     /^#\s+End\s+hostnames/ && do {
-	$desthandle->close();
+	close(FILE);
 	$destfile = "";
 	next;
     };
 
-    # Generate gateway configuration info, one file per line
-    $gateways && do {
-	chomp;
-	my($dtb, $myname, $desthost, $type) = split(" ", $_);
-
-	# Many of these are to simplify print statements
-	my $sdomain =				# domain for the source
-	    $tbparams->{$gateways}->{'domain'};
-	my $ddomain =				# domain for the destination
-	    $tbparams->{$dtb}->{'domain'};
-	my $sproject =				# Project of the source
-	    $tbparams->{$gateways}->{'project'};
-	my $dproject =				# Project of the destination
-	    $tbparams->{$dtb}->{'project'};
-	my $fs =				# Master fs node (FQDN)
-	    $tbparams->{$master}->{'fs'} .  $tbparams->{$master}->{'domain'};
-	my $boss =				# Master boss node (FQDN)
-	    $tbparams->{$master}->{'boss'} .  $tbparams->{$master}->{'domain'};
-	my $event_server =			# Master event-server (FQDN)
-	    $tbparams->{$master}->{'eventserver'} .  
-	    $tbparams->{$master}->{'domain'};
-	my $remote_event_server =		# Slave event-server (FQDN)
-	    $tbparams->{$dtb}->{'eventserver'} .  
-	    $tbparams->{$dtb}->{'domain'};
-	my $remote_script_dir =			# Remote fed script location
-	    "/proj/" . $dproject . "/exp/$eid/tmp";
-	my $local_script_dir =			# Local fed script location
-	    "/proj/" . $sproject . "/exp/$eid/tmp";
-	my $active;				# Is this the active side of
-						# the connector?
-	my $tunnel_cfg =			# Use DETER's config stuff
-	    $tbparams->{$gateways}->{'tun'} || "false";
-				    
-
-	$sdomain = ".$eid." . $tbparams->{$gateways}->{'project'} . "$sdomain";
-	$ddomain = ".$eid." . $tbparams->{$dtb}->{'project'} . "$ddomain";
-
-	my $conf_file = "$myname$sdomain.gw.conf";
-	my $remote_conf_file = "$desthost$ddomain.gw.conf";
-	# translate to lower case so the `hostname` hack for specifying
-	# configuration files works.
-	$conf_file =~ tr/A-Z/a-z/;
-	$remote_conf_file =~ tr/A-Z/a-z/;
-
-	# If either end of this link is in the master side of the testbed, that
-	# side is the active end. Otherwise the first testbed encountered in
-	# the file will be the active end.  The $active_end variable keeps
-	# track of those decisions
-	if ( $dtb eq $master ) { $active = "false"; }
-	elsif ($gateways eq $master ) { $active = "true"; }
-	elsif ( $active_end{"$dtb-$gateways"} ) { $active="false"; }
-	else { $active_end{"$gateways-$dtb"}++; $active = "true"; }
-
-	# This is used to create the client configuration.
-	$control_gateway = "$myname$sdomain"
-	    if $type =~ /(control|both)/;
-
-	# Write out the file
-	my $gwconfig = new IO::File(">$tmpdir/$gateways/$conf_file")|| 
-	    die "can't open $tmpdir/$gateways/$conf_file: $!\n";
-
-	print $gwconfig "Active: $active\n";
-	print $gwconfig "TunnelCfg: $tunnel_cfg\n";
-	print $gwconfig "BossName: $boss\n";
-	print $gwconfig "FsName: $fs\n";
-	print $gwconfig "EventServerName: $event_server\n";
-	print $gwconfig "RemoteEventServerName: $remote_event_server\n";
-	print $gwconfig "Type: $type\n";
-	print $gwconfig "RemoteScriptDir: $remote_script_dir\n";
-	print $gwconfig "EventRepeater: $local_script_dir/fed_evrepeater\n";
-	print $gwconfig "RemoteExperiment: $dproject/$eid\n";
-	print $gwconfig "LocalExperiment: $sproject/$eid\n";
-	print $gwconfig "RemoteConfigFile: " . 
-	    "$remote_script_dir/$remote_conf_file\n";
-	print $gwconfig "Peer: $desthost$ddomain\n";
-	print $gwconfig "Pubkeys: " . 
-	    "/proj/$sproject/exp/$eid/tmp/$gw_pubkey_base\n";
-	print $gwconfig "Privkeys: " .
-	    "/proj/$sproject/exp/$eid/tmp/$gw_secretkey_base\n";
-	$gwconfig->close();
-
-	# This testbed has a gateway (most will) so make a copy of the keys it
-	# needs in this testbed's subdirectory.  start_segment will transfer
-	# them.
-	unless (-r "$tmpdir/$gateways/$gw_pubkey_base" ) {
-	    copy($gw_pubkey, "$tmpdir/$gateways/$gw_pubkey_base") ||
-		die "Can't copy pubkeys ($gw_pubkey to " . 
-		    "$tmpdir/$gateways/$gw_pubkey_base): $!\n";
-	}
-	if ($active eq "true" ) {
-	    unless (-r "$tmpdir/$gateways/$gw_secretkey_base" ) {
-		copy($gw_secretkey, "$tmpdir/$gateways/$gw_secretkey_base") ||
-		    die "Can't copy secret keys ($gw_secretkey to " . 
-			"$tmpdir/$gateways/$gw_secretkey_base): $!\n";
-	    }
-	}
-
-	#done processing gateway entry, ready for next line
-	next; 
-    };
-    (/^#\s+Begin\s+tarfiles/../^#\s+End\s+tarfiles/) && do {
-	next if /^#/;
-	chomp;
-	push(@tarfiles, $_);
-	next;
-    };
-    (/^#\s+Begin\s+rpms/../^#\s+End\s+rpms/) && do {
-	next if /^#/;
-	chomp;
-	push(@rpms, $_);
-	next;
-    };
-
     next unless $destfile;  # Unidentified testbed, ignore config
-    # local copies that can be used in the substitutions below
-    my $gwtype = $tbparams->{$ctb}->{'gwtype'} || $def_gwtype;
-    my $gwimage = $tbparams->{$ctb}->{'gwimage'} || $def_gwimage;
-    my $mgwstart = $tbparams->{$ctb}->{'mgwstart'} || $def_mgwstart;
-    my $mexpstart = $tbparams->{$ctb}->{'mexpstart'} || $def_mexpstart;
-    my $gwstart = $tbparams->{$ctb}->{'gwstart'} || $def_gwstart;
-    my $expstart = $tbparams->{$ctb}->{'expstart'} || $def_expstart;
-    my $project = $tbparams->{$ctb}->{'project'};
 
     # Substitute variables
-    s/GWTYPE/$gwtype/g;
-    s/GWIMAGE/$gwimage/g;
+    s/GWTYPE/$gwtype{$ctb}/g;
+    s/GWIMAGE/$gwimage{$ctb}/g;
     if ($ctb eq $master ) {
-	s/GWSTART/$mgwstart/g;
-	s/EXPSTART/$mexpstart/g;
+	s/GWSTART/$mgwstart{$ctb}/g;
+	s/EXPSTART/$mexpstart{$ctb}/g;
     }
     else {
-	s/GWSTART/$gwstart/g;
-	s/EXPSTART/$expstart/g;
-    }
-    # XXX: oh is this bad
-    s#GWCONF#FEDDIR\`hostname\`.gw.conf#g;
-    s#PROJDIR#/proj/$project/#g;
-    s#EID#$eid#g;
-    s#FEDDIR#/proj/$project/exp/$eid/tmp/#g;
-    print $desthandle $_;
-}
-$pipe->close();
+	s/GWSTART/$gwstart{$ctb}/g;
+	s/EXPSTART/$expstart{$ctb}/g;
+    }
+    print FILE;
+}
+close(PIPE);
 die "No nodes in master testbed ($master)\n" unless $allocated{$master};
 
-# Copy tarfiles and rpms needed at remote sites to the staging directories.
-# Start_segment will distribute them
-for my $t  (@tarfiles) {
-    die "tarfile '$t' unreadable: $!\n" unless -r $t;
-    unless (-d "$tmpdir/tarfiles") {
-	mkdir("$tmpdir/tarfiles") || 
-	    die "Can't create $tmpdir/tarfiles:$!\n";
-    }
-    copy($t, "$tmpdir/tarfiles") || 
-	die "Can't copy $t to  $tmpdir/tarfiles:$!\n";
-}
-
-for my $r  (@rpms) {
-    die "rpm '$r' unreadable: $!\n" unless -r $r;
-    unless (-d "$tmpdir/rpms") {
-	mkdir("$tmpdir/rpms") || 
-	    die "Can't create $tmpdir/rpms:$!\n";
-    }
-    copy($r, "$tmpdir/rpms") || 
-	die "Can't copy $r to  $tmpdir/rpms:$!\n";
-}
-
 exit(0) unless $startem;
-
-my %started;		    # If $started{$tb} then $tb successfully started
-my %child;		    # If $child{$pid} then a process with that pid is
-			    # working on a starting a segment
-my $nworking = 0;	    # Number of children working on swapin
-my $pid;		    # Scratch variable for pids
 
 # Start up the slave sub-experiments first
 TESTBED:
-for my $tb  (keys %allocated) {
-    if ( $tb ne $master ) {
-	while ( $nworking == $max_children ) {
-	    print "Waiting for a child process to complete\n" if $verbose;
-	    if (($pid = wait()) != -1 ) {
-		# The $? >> 8 is the exit code of the subprocess, which is
-		# non-zero if the &start_segment routine failed.
-		my $exit_code = ($? >> 8);
-
-		print "Child $pid completed exit code ($exit_code)\n"
-		    if $verbose;
-		$nworking--;
-		$started{$child{$pid}}++ unless $exit_code;
-		if ($child{$pid} ) { delete $child{$pid}; }
-		else { warn "Reaped a pid we did not start?? ($pid)\n"; }
-		last TESTBED if $exit_code;
-	    }
-	    else { warn "wait returned without reaping: $!\n"; }
-	}
-	if ( $pid = fork() ) {
-	    # Parent process
-	    $nworking ++;
-	    $child{$pid} = $tb;
-	    print "Started process $pid to start testbed $tb\n"
-		if $verbose;
-	}
-	else {
-	    # Child.  Note that we reverse the sense of the return code when it
-	    # becomes an exit value.  Zero exit values indicate success.
-	    exit(!&start_segment($tb, $eid, $tbparams, $timeout));
-	}
-    }
-}
-
-# Now wait for any still running processes.
-while ( $nworking ) {
-    print "Waiting for a child process to complete ($nworking running)\n" 
-	if $verbose;
-    if (($pid = wait()) != -1 ) {
-	# The $? >> 8 is the exit code of the subprocess, which is
-	# non-zero if the &start_segment routine failed.
-	my $exit_code = ($? >> 8);
-
-	print "Child $pid completed exit code ($exit_code)\n"
-	    if $verbose;
-	$nworking--;
-	$started{$child{$pid}}++ unless $exit_code;
-	if ($child{$pid} ) { delete $child{$pid}; }
-	else { warn "Reaped a pid we did not start?? ($pid)\n"; }
-    }
-    else { warn "wait returned without reaping: $!\n"; }
+for $tb (keys %allocated) {
+    if ($tb ne $master) {
+	if (&start_segment($tb, $eid)) { $started{$tb}++; }
+	else { last TESTBED; }
+    }
 }
 
 # Now the master
-if (&start_segment($master, $eid, $tbparams, $timeout)) { 
+if (&start_segment($master, $eid)) { 
     $started{$master}++;
 }
 
 # If any testbed failed, swap the rest out.
-if ( !$fail_soft && scalar(keys %started) != scalar(keys %allocated)) {
-    for my $tb (keys %started) { &stop_segment($tb, $eid, $tbparams); }
+if ( scalar(keys %started) != scalar(keys %allocated)) {
+    for $tb (keys %started) { &stop_segment($tb, $eid); }
     print "Error starting experiment\n";
     exit(1);
 }
 print "Experiment started\n";
-print "Deleting $tmpdir (-d to leave them in place)\n" if $verbose && !$debug;
-system("rm -rf $tmpdir") unless $debug;
 exit(0);    # set the exit value
 
@@ -1139,6 +264,6 @@
 =head1 SYNOPSIS
 
-B<splitter.pl> [B<-ndF>] [B<-t> I<secs>] [B<-c> F<config_file>]
-    [B<-f> F<experiment_tcl>] [B<-p> I<max_procs>] [F<experiment_tcl>]
+B<splitter.pl> B<-e> I<experiment> B<-m> I<master_testbed> [B<-n>] 
+    [B<-c> I<config_file>] [B<-f> I<experiment_tcl>] [I<experiment_tcl>]
 
 =head1 DESCRIPTION
@@ -1149,149 +274,35 @@
 tb-set-node-testbed command, added to the parser.
 
-Much of the script's behavior depends on the configuration file, specified with
-the B<-c> flag and defaulting to F<./splitter.conf>.
-
-The testbed labels supplied in the B<tb-set-node-testbed> command are
-meaningful based on their presence in the testbeds file.  that file can be
-specified in the configuration file using the B<Testbeds> directive, and
-defaults to F<./testbeds>.  The syntax is described below.
-
-Most of the intermediate files are staged in a sub-directory of a temporary
-files directory and deleted at the end of the script.  Specifying the B<-d>
-flag on the command line avoids the deletion for debbugging.  By default the
-temporary files directory is directory is F</tmp> and can be reset in the
-configuration file using the B<Tmpdir> directive.  Intermediate files are
-stored under a subdirectory formed by adding the process ID of the splitter
-process.  For example, if the temporary files directory is F</tmp> and the
-B<splitter.pl> process ID is 2323, the temporary files will be stored in
-F</tmp/split2323/>.
+The testbed labels are meaningful based on their presence in the testbeds file.
+that file can be specified with the B<-c> option, and defaults to
+F<./testbeds>.  The syntax is described below.
 
 The expreriment is split out into one experiment description per testbed in the
-temporary directory named as F<experiment.testbed.tcl> where the experiment is
-the experiment ID given in the configuration file, and the testbed is the
-tb-set-node-testbed parameter for the nodes in the file.
+current directory named as F<experiment.testbed.tcl> where the experiment is
+the argument to B<-e> and the testbed is the tb-set-node-testbed parameter for
+the nodes in the file.
 
 If the B<-n> option is absent the sub-experiments are then instantiated on
 their testbeds.  (Here B<-n> is analogous to its use in L<make(1)>).
-Per-testbed parameters are set in the testbeds file.  Sub-experiments on
+Per-testbed parameters are set in the configuration file.  Sub-experiments on
 slave testbeds are instantiated in a random order, but the master testbed is
 currently instantiated last.
 
-Slave testbeds can be swapped in in parallel by specifying the B<-p> parameter
-and the maximum number of simultaneous processes to start.
-
-Scripts to start federation (the federation kit) are copied into the local
-experiment's tmp file - e.g., F</proj/DETER/exp/simple-split/tmp>.  These are
-taken from the directory given by the B<ScriptDir> directive in the
-configuration file.
-
-If B<-t> is given the parameter is treated as a parameter to B<Timeout> in 
-F<splitter.conf>.
-
 If any sub-experiment fails to instantiate, the other sub-exeriments are
-swapped out.  B<-F> avoids this swap out, which can also be specified as 
-B<SoftFail: true> in F<splitter.conf>
-
-=head2 Configuration File
-
-The configuration file is a simple set of colon-separated parameters and
-values.  A configuration file must be present, either specified in the B<-c>
-flag or the default F<./splitter.conf>.  All the parameter names are case
-insensitive, but should not include any whitespace.  Parameter values may
-include whitespace, but no newlines.
-
-Possible parameters are:
+swapped out.
+
+=head2 Configuration file
+
+The configuration file (F<./testbeds> unless overridden by B<-c>) is a
+colon-separated set of parameters keyed by testbed name.  The fields, in order,
+are:
 
 =over 5
 
-=item Experiment
-
-The name of the experiment on the various testbeds
-
-=item Master
-
-The master testbed label from the testbeds file, described below.
-
-=item Testbeds
-
-The testbeds file described below, giving per-testbed parameters.  If this
-directive is absent the testbeds file defaults to F<./testbeds>
-
-=item ScriptDir
-
-Location of the default federation scripts, i.e. the federation kit.
-
-=item GatewayPubkey
-
-=item GatewaySecretKey
-
-The names of the files containing secret and public keys to use in setting up
-tunnels between testbeds.  If given they are used, otherwise keys are generated.
-
-=item GatewayKeyType
-
-This controls the kind of SSH keys generated to configure the geatways.  If
-given this must be B<dsa> or B<rsa>, and it defaults to B<rsa>.  The parameter
-is csase insensitive.
-
-=item TmpDir
-
-=item TempDir
-
-The directory where temporary files are created.  These are synonyms, but
-should both be specified, B<TmpDir> has priority.  If neither is specified,
-F</tmp> is used.
-
-=item SMBShare
-
-The SMB share on the master testbed that will be exported to remote clients.
-
-=item SMBUser
-
-The experiment user to mount project directories as.  This user needs to be a
-member of the exported experiment - that is one of the users in the project
-containing this experiment on the master testbed.
-
-=item Timeout
-
-Value in seconds after which a swap-in operatioin will be considered a success.
-Often long swap-ins will hang when there are partial failures.  This works
-around this issue.  (This behavior can be requested on the command line by
-specifying B<-t> I<secs>.)
-
-=item FailSoft
-
-If not set, failure of any sub experiment swaps the rest out.  Setting this to
-any value avoids this swap out.  (This behavior can be requested on the command
-line by specifying B<-F>.)
-
-=item MuxLimit
-
-The maximum bumber of links/lans carried by one gateway pair
-
-=item Tclparse
-
-The pathname to the experiment parsing program.  Only developers should set
-this.
-
-=item Tclsh
-
-The pathname to the local oTcl shell.  Only developers should set
-this.
-
-=back
-
-=head2 Testbeds file
-
-The configuration file (F<./testbeds> unless overridden by B<-c>) is a file of
-scoped attribute-value pairs where each attribute is specified on a separate
-line of the configuration file.  Each testbed's parameters are preceeded by the
-testbed label in brackets ([]) on a line by itself.  After that the parameters
-are specified as parameter: value.  This is essentially the same format as the
-configuration file.  Parameters are:
-
-=over 4
-
-=item User
+=item name
+
+The testbed to which this line of parameters applies.
+
+=item user
 
 The user under which to make requests to this testbed.  The user running
@@ -1299,87 +310,40 @@
 testbed.
 
-=item OpsNode
-
-The host name of the testbed's ops node.  The user calling B<splitter.pl> must
-be able to execute commands on this host via L<ssh(1)>.
-
-=item Domain
-
-The domain of nodes in this testbed (including the ops host).  This parameter
-should always start with a period.
-
-=item Project
+=item project
 
 The project under which to instantiate sub-experiments on this testbed.
 
-=item ConnectorType
-
-The node type for inter-testbed connector nodes on this testbed.
-
-=item SlaveNodeStartCmd
+=item gateway type
+
+The node type for inter-testbed gateway nodes on this testbed.
+
+=item experiment start (slave)
 
 The start command to run on experimental nodes when this testbed is used as a
-slave.  In all the start commands the following string substitutions are made:
-
-=over 10
-
-=item FEDDIR
-
-The local experiment's federation scripts directory.  Each local experiment
-will have this replaced by the scripts directory on its local boss.
-
-=item GWCONF 
-
-The full pathname of the gateway configuration file.  As with FEDDIR, this is
-on the local boss.
-
-=item PROJDIR
-
-The project directory on the local boss.
-
-=item EID
-
-The local experiment name.
+slave.
+
+=item gateway start (slave)
+
+The start command to run on gateway nodes when this testbed is used as a
+slave.
+
+=item experiment start (master)
+
+The start command to run on experimental nodes when this testbed is used as a
+master.
+
+=item gateway start (master)
+
+The start command to run on gateway nodes when this testbed is used as a
+master.
+
+=item gateway image
+
+The disk image to be loaded on a gateway node on this testbed.
 
 =back
 
-All startcmds specified in F<testbeds> undergo these expansions.
-
-=item SlaveConnectorStartCmd
-
-The start command to run on gateway nodes when this testbed is used as a slave.
-The same string substitutions are made in this command as in SlaveNodeStartCmd.
-
-=item MasterNodeStartCmd
-
-The start command to run on experimental nodes when this testbed is used as a
-master.  The same string substitutions are made in this command as in
-SlaveNodeStartCmd.
-
-=item MasterConnectorStartCmd
-
-The start command to run on gateway nodes when this testbed is used as a
-master.  The same string substitutions are made in this command as in
-SlaveNodeStartCmd.
-
-=item ConnectorImage
-
-The disk image to be loaded on a gateway node on this testbed.
-
-=item FileServer
-
-The node in the master testbed from which filesystems are mounted.
-
-=item Boss
-
-The node in the master testbed that controls the testbed.
-
-=item TunnelCfg
-
-True if the connector needs to do DETER federation.  This parameter will
-probably be removed.
-
-
-=back
+The parsing of the configuration is extremely simple.  Colons separate each
+field and there is n provision for escaping them at this time.
 
 =head1 ENVIRONMENT
@@ -1389,10 +353,4 @@
 environment.
 
-=head1 BUGS
-
-A deprecated B<-N> flag was used to select testbeds file format.  Only one
-format is supported now, and B<-N> generates a warning, but otherwise does not
-affect B<splitter.pl>.
-
 =head1 SEE ALSO
 
